  var log;
  //~ var url = "http://118.98.232.10/opac/api/index.php/";
  //~ var url = "http://perpustakaan.kemdikbud.go.id/opac/api/index.php/";
  //~ var url = "http://localhost/api/isi-yogya/index.php/";
  //~ var url = "http://files.sutriadi.web.id/API/isi-yogya/index.php/";
  //~ var url = "http://s.sutriadi.com/api-isi-yogya/index.php/";
  var url = "http://opac.isi.ac.id/api/main/index.php/";

  angular.module('app', ['onsen', 'ngSanitize']);

  angular.module('app').factory('$opac', function() {
    var data = {};
    
    data.items = [];
    return data;
  });

  angular.module('app').factory('$keyword', function() {
    return '';
  });

  angular.module('app').factory('$node', function() {
    return {};
  });

  angular.module('app').factory('$items', function() {
    var data = {};
    
    data.items = [];
    return data;
  });

  angular.module('app').factory('$news', function() {
    var data = {};
    data.current = {};
    data.loaded = false;
    data.items = [];
    
    return data;
  });

  angular.module('app').controller('AppController', function($scope, $opac, $news, $http) {
    ons.ready(function() {
      if ($news.loaded == false) {
        modal.show();

        var req = {};
        req.method = 'GET';
        req.url = url + "news";

        var resp = $http(req);
        resp.success(function(data, status, headers, config) {
          //~ console.log(data);
          $news.items = data;
          $news.loaded = true;
          $scope.news = $news.items;
          modal.hide();
        });
        resp.error(function(data, status, headers, config) {
          console.log("AJAX Failed");
          modal.hide();
        });
      }
      else {
        $scope.news = $news.items;
      }
    });

    $scope.doNews = function(index) {
      var selectedItem = $news.items[index];
      $news.selectedItem = selectedItem;
      $scope.beritaNav.pushPage('berita_isi.html');
    };

    $scope.current = {};
    $scope.current.node = {};
    $scope.current.biblio = {};

    $scope.doSearch = function() {
      modal.show();
      $scope.keyword = document.getElementById('search-keyword').value;
      
      $opac.page = 0;

      var data = {};
      data.keyword = $scope.keyword;
      data.page = $opac.page;
      data.index = 'katalog';

      var req = {};
      req.method = 'POST';
      req.url = url + "list";
      req.headers = { 'Content-Type': undefined };
      req.data = data;

      var resp = $http(req);
      resp.success(function(data, status, headers, config) {
        $opac.list = data;
        $scope.opacNav.pushPage('result.html');
        modal.hide();
        if (data.nums > 1)
          $opac.page = 1;
      });
      resp.error(function(data, status, headers, config) {
        console.log(headers);
        console.log("AJAX Failed");
        modal.hide();
      });
      
    };

  });

  angular.module('app').controller('NewsController', function($scope, $http, $news) {
    console.log($news.selectedItem);
    $scope.news = $news.selectedItem;
    
    $scope.doWeb = function() {
      window.open(decodeURIComponent($scope.news.link));
    };
  });

  angular.module('app').controller('ContactController', function($scope) {
    $scope.doCall = function(number) {
      document.location.href = 'tel:'+number;
    }
    $scope.doFax = function(number) {
      document.location.href = 'fax:'+number;
    }
    $scope.doMail = function(addr) {
      document.location.href = 'mailto:'+addr;
    }
    $scope.doApp = function(url) {
      window.open(url, '_system');
    }
    $scope.doMap = function(lat, lon, label) {
      document.location.href = 'geo:'+lat+','+lon+'?q='+lat+','+lon+'('+label+')';
    }
    $scope.doInfo = function() {
      info.show();
    }
  });

  angular.module('app').controller('ResultController', function($scope, $opac, $http) {
    if (!$scope.current.node) {
      $scope.current.node = {};
    }
    $scope.current.node.total = $opac.list.total;
    $scope.items = $opac.list.items;
    
    $scope.doLoadMore = function() {
      var data = {};
      data.keyword = $scope.keyword;
      data.page = $opac.page;
      data.index = 'katalog';

      modal.show();

      var req = {};
      req.method = 'POST';
      req.url = url + "list";
      req.headers = { 'Content-Type': undefined };
      req.data = data;

      var resp = $http(req);
      resp.success(function(data, status, headers, config) {
        for (i = 0; i < data.items.length; i++)
          $scope.items.push(data.items[i]);
        if (data.items.length > 1)
          $opac.page = $opac.page + 1;
        modal.hide();
      });
      resp.error(function(data, status, headers, config) {
        console.log(headers);
        console.log("AJAX Failed");
        modal.hide();
      });
    }
    
    $scope.showDetail = function(index) {
      var selectedItem = $opac.list.items[index];
      $opac.biblio = selectedItem;
      
      modal.show();

      var data = {};
      data.id = selectedItem.id;
      data.index = 'katalog';

      var req = {};
      req.method = 'POST';
      req.url = url + "detail";
      req.headers = { 'Content-Type': undefined };
      req.data = data;

      var resp = $http(req);
      resp.success(function(data, status, headers, config) {
        $opac.detail = data;
        log = data;
        $scope.opacNav.pushPage('detail.html');
        modal.hide();
      });
      resp.error(function(data, status, headers, config) {
        console.log("AJAX Failed");
        modal.hide();
      });
    };
  });
  
  angular.module('app').controller('DetailController', function($scope, $opac, $http) {
    $scope.current.node = $opac.current;
    $scope.item = $opac.biblio;
    $scope.detail = $opac.detail.items;
    
    $scope.doDetails = function(doer) {
      modal.show();
      var data = {};
      data.id = $opac.biblio.id;
      data.index = 'katalog';

      var req = {};
      req.method = 'POST';
      req.headers = { 'Content-Type': undefined };
      req.data = data;

      switch (doer) {
        case true:
          req.url = url + "files";
          
          var resp = $http(req);
          resp.success(function(data, status, headers, config) {
            //~ console.log(data);
            log = data;
            $opac.files = data;
            $scope.homeNav.pushPage('attachment.html');
            modal.hide();
          });
          resp.error(function(data, status, headers, config) {
            console.log(headers);
            console.log("AJAX Failed");
            modal.hide();
          });

          break;
        default:
          req.url = url + "items";
          
          var resp = $http(req);
          resp.success(function(data, status, headers, config) {
            //~ console.log(data);
            log = data;
            $opac.exp = data;
            $scope.opacNav.pushPage('exemplar.html');
            modal.hide();
          });
          resp.error(function(data, status, headers, config) {
            console.log(headers);
            console.log("AJAX Failed");
            modal.hide();
          });
      }
    };
  });

  angular.module('app').controller('AttachmentController', function($scope, $opac) {
    $scope.current.biblio = $opac.biblio;
    $scope.files = $opac.files;
    
    $scope.doView = function(index) {
      //~ console.log($opac.files[index]);
      window.open($opac.files[index].link, '_blank', 'location=no');
    }
  });

  angular.module('app').controller('ExpController', function($scope, $opac) {
    $scope.current.biblio = $opac.biblio;
    $scope.exps = $opac.exp;
  });
